import CPU from './cpu';
import Keyboard from './keyboard'
import RNG from './RNG'

class Chip8Emulator {
	
	cpu: CPU;
	keyboard: Keyboard;

	rom: Uint8Array;

	constructor() {
		
		this.cpu = new CPU();
		this.keyboard = new Keyboard();
		this.rom = new Uint8Array();
	}

	loadRom(rom: Uint8Array) {
		this.rom = rom;
	}

	emulateCycle() {
		// Fetch opcode
		// Decode opcode
		// Execute opcode

		// Update timers
	}

	drawGraphics() {

	}

	drawToCanvas(canvas: HTMLCanvasElement, size: number) {
		let ctx = canvas.getContext('2d') as CanvasRenderingContext2D;
		let width = 64*size;
		let height = 32*size;

		// Clear screen
		ctx.fillStyle = "BLACK";
		ctx.fillRect(0, 0, width, height);

		// Draw rectangles as pixels
		for(let i = 0; i < this.cpu.displayMemory.length; i++) {
			let isOn: number = this.cpu.displayMemory[i];
			if(isOn === 1) {
				let y = Math.floor(i/width);
				let x = i - (y*width);

				ctx.fillStyle = "WHITE";
				ctx.fillRect(x, y, 1, 1);
			}
		}
	}

	keyDownEvent(key: number) {
		this.keyboard.userKeyPressedDown(key);
	}

	keyUpEvent(key: number) {
		this.keyboard.userKeyPressedUp(key);
	}



}

export default Chip8Emulator;